from tw.api import Widget, JSLink, CSSLink, JSSource

from tw.extjs import all
from paraxip.gateway_gui_widgets import base, debug, extjsOverrides
import os

class TreeViewJS(JSSource):
    _resources = []
    source_vars = params = ["renderTo", "fetch","src_file"]
    #treeDiv__doc=""
    #renderTo         = 'tree'
    fetch = 'fetch'
    src = ""
    # src =  load_src("pstnconfig/static/javascript/widgets_src/editor.js")
    template_engine=""
    boards_script = JSLink(link="/static/javascript/widgets_src/editor/boards.js")
    physical_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/physical_config.js")
    digital_physical_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/digital_physical_config.js")
    analog_physical_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/analog_physical_config.js")
    call_control_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/call_control_form.js")
    isdn_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/isdn_config.js")
    cas_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/cas_config.js")
    analog_config_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/analog_config.js")
    channel_group_script = \
                    JSLink(link="/static/javascript/widgets_src/editor/channel_group.js")
    javascript=[all,
                base.oam_common_lib_script,
                base.css_override, 
                debug.paraxip_console_script,
                extjsOverrides.overrides_script, 
                base.pstn_config_doc_script,
                boards_script,
                physical_config_script,
                digital_physical_config_script,
                analog_physical_config_script,
                call_control_script,
                isdn_config_script,
                cas_config_script,
                analog_config_script,
                channel_group_script
               ]
                
    def __init__(self, *args, **kw):
        super(TreeViewJS, self).__init__(*args, **kw)
    
    def update_params(self, d):
        for param in self.source_vars:
            value = getattr(self, param)
            if isinstance(value, bool):
                d[param] = str(value).lower()
        super(TreeViewJS, self).update_params(d)
    def post_init(self, *args, **kw):
        pass
   
    

treeview_js = TreeViewJS()
    
class TreeViewPSTN(Widget):
    treeview_js_obj = TreeViewJS
    params = js_params =   ["renderTo", 
                            "fetch",
                            "src_file"]

    template = """<div id="$renderTo" />"""
    
    #title = 'Override JS Title'
    
    def __new__(cls, *args, **kw):
        cls = Widget.__new__(cls, *args, **kw)
        d = {}
        
        #copy in parameters from this class to the javascript class (keeps all of the params in one place)
        for param in cls.js_params:
            value = getattr(cls, param)
            if value is not None:
                d[param] = getattr(cls, param)
                if param == "src_file":
                    cls.treeview_js_obj.src = cls.load_src(value)

        treeview_js = cls.treeview_js_obj(**d)
        cls.javascript = [treeview_js,]
        return cls

    def load_src(self, src_name):
        """
        src_name == dotted.path.to.template (without .ext)
        
        """
        src_file = open(src_name)
        src_obj = src_file.read()
        src_file.close()
        return src_obj      
      
## !!MIRROR FILE, DO NOT MODIFY!!
