# Python class implementing the JRunnable interface, used in PythonJRunnable.t.cpp

#JRunnable interface
#run_i()
#terminate()

import time
from paraxip.infra.PyLoggingFunctions import log_info
import netborderPyInfra

class PythonJRunnableTestBase:

  def __init__(self, in_Logger):
    self._logger = in_Logger
    self._terminated = False

  # JRunnable I/F
  def run_i(self):
    log_info(self._logger, 'run_i')
    while(not self._terminated):
      time.sleep(1)

  def terminate(self):
    log_info(self._logger, 'terminate')
    self._terminated = True

class PythonJRunnableTest1(PythonJRunnableTestBase):

  def __init__(self, in_Logger):
    PythonJRunnableTestBase.__init__(self, in_Logger)
    log_info(self._logger, 'Test1 ctor')

class PythonJRunnableTest2(PythonJRunnableTestBase):

  def __init__(self):
    PythonJRunnableTestBase.__init__(self, netborderPyInfra.Logger(
        'netborder.test.PythonJRunnableTest2'))
    log_info(self._logger, 'Test2 ctor')
## !!MIRROR FILE, DO NOT MODIFY!!
