<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a gw.properties from a gateway version of 3.0.1 to
version 3.0.2. To do so:

If sip.reliableProvisionalResponse=as-needed, add 
sip.interpretSupported100RelAsRequire=true. As-needed behavior has been 
changed between those version.

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<!-- If reliableProvisionalResponse=as-needed add element
interpretSupported100RelAsRequire -->
<xsl:template match="sip">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
    <xsl:if test="reliableProvisionalResponse[@value='as-needed']">
      <xsl:element name="interpretSupported100RelAsRequire">
        <xsl:attribute name="value">true</xsl:attribute>
        <xsl:attribute name="defined">true</xsl:attribute>
      </xsl:element>
    </xsl:if>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet> 
