<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a oamWebServer.properties from a gateway version of 4.1.3 to
version 4.2.0. To do so:

Extract the following parameters and import their values in file wizard.properties:

* netborder.oamWebServer.defaultUDPListenPort=5066  -> netborder.oamWebServer.sip.udp.listenPort
* netborder.oamWebServer.defaultTCPListenPort=5066 -> netborder.oamWebServer.sip.tcp.listenPort
* netborder.oamWebServer.defaultTLSListenPort=5067 -> netborder.oamWebServer.sip.tls.listenPort
* netborder.oamWebServer.defaultUDPTCPSendPort=5060 -> netborder.oamWebServer.sip.primarySipServerUDPTCPPort
                                                        netborder.oamWebServer.sip.failover.backupSipServerUDPTCPPort
* netborder.oamWebServer.defaultTLSSendPort=5061 -> netborder.oamWebServer.sip.primarySipServerTLSPort
                                                        netborder.oamWebServer.sip.failover.backupSipServerTLSPort

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="/">
	<xsl:element name="netborder">
		<xsl:element name="oamWebServer">
			<xsl:element name="sip">
				<xsl:element name="udp">
					<xsl:apply-templates mode="udp"/>
				</xsl:element>
				<xsl:element name="tcp">
					<xsl:apply-templates mode="tcp"/>
				</xsl:element>
				<xsl:element name="tls">
					<xsl:apply-templates mode="tls"/>
				</xsl:element>
				<xsl:element name="failover">
					<xsl:apply-templates mode="failover"/>
				</xsl:element>				
				<xsl:apply-templates mode="sip"/>
			</xsl:element>
		</xsl:element>
	</xsl:element>
</xsl:template>

<!-- Add defaultUDPListenPort -->
<xsl:template match="netborder/oamWebServer/defaultUDPListenPort" mode="udp">
	<xsl:element name="listenPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<!-- Add defaultTCPListenPort -->
<xsl:template match="netborder/oamWebServer/defaultTCPListenPort" mode="tcp">
	<xsl:element name="listenPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<!-- Add defaultTLSListenPort -->
<xsl:template match="netborder/oamWebServer/defaultTLSListenPort" mode="tls">
	<xsl:element name="listenPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<!-- add defaultTCPUDSendPort -->
<xsl:template match="netborder/oamWebServer/defaultUDPTCPSendPort" mode="sip">
	<xsl:element name="primarySipServerUDPTCPPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<xsl:template match="netborder/oamWebServer/defaultUDPTCPSendPort" mode="failover">
	<xsl:element name="backupSipServerUDPTCPPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<!-- Add defaultTLSSendPort -->
<xsl:template match="netborder/oamWebServer/defaultTLSSendPort" mode="sip">
	<xsl:element name="primarySipServerTLSPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

<xsl:template match="netborder/oamWebServer/defaultTLSSendPort" mode="failover">
	<xsl:element name="backupSipServerTLSPort">
		<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
		<xsl:attribute name="defined"><xsl:value-of select="@defined"/></xsl:attribute>
	</xsl:element>	
</xsl:template>

</xsl:stylesheet> 

