<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a pstn-config from a gateway version of 4.2.3 to version
4.3.0. To do so:

-Xml version need to be changed to 4.2
  Gateway 4.1.2 -> pstn-config 3.1
  Gateway 4.1.3 -> pstn-config 4.1
  Gateway 4.2.3 -> pstn-config 4.1
  Gateway 4.3.0 -> pstn-config 4.2


 - Added overlapDigitsReception paramerter as DISABLED for both bri, fas and nfas configs
 
 - Added analogFxoFakePolarityEnabled parameter as NO for analog physical config
-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 


<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<!-- Set pstnConfig version to 4.2 -->
<xsl:template match="pstnConfig">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="version">4.2</xsl:attribute>
    <xsl:apply-templates select="node()"/>
  </xsl:copy>
</xsl:template>

<!-- 
Add overlapDigitsReception parameter
-->
<xsl:template match="briConfig">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>    
    <xsl:attribute name="overlapDigitsReception">DISABLED</xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="fasConfig">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>    
    <xsl:attribute name="overlapDigitsReception">DISABLED</xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="nfasGroup">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>    
    <xsl:attribute name="overlapDigitsReception">DISABLED</xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="analog[@variant]">
    <xsl:copy>
      <xsl:apply-templates select="@*"/>    
      <xsl:attribute name="analogFxoFakePolarityEnabled">NO</xsl:attribute>
      <xsl:apply-templates/>
    </xsl:copy>
</xsl:template>



</xsl:stylesheet> 
