//-----------------------------------------------
// Main form that contains all the fields
//-----------------------------------------------
Ext.namespace("Paraxip.wizard");

var hardware_form = new Ext.Panel({
  title       : "Hardware Configuration"
  ,layout     : 'border'
  ,frame      : true
  ,hideMode   : 'offsets'
  ,header     : false
  ,id         : "Paraxip.wizard.hardware_form"
  ,items      : [{
    xtype: 'panel'
    ,region: 'west'
    ,layout: 'fit'
    ,margins: '5 0 0 0'
    ,cmargins: '5 5 0 0'
    ,width: 20
    ,height: 400
    ,minSize: 120
  },{
    xtype: 'panel'
    ,region: 'east'
    ,layout: 'fit'
    ,margins: '5 0 0 0'
    ,cmargins: '5 5 0 0'
    ,width: 20
    ,height: 400
    ,minSize: 120
  }]
});

// North panel: Simple description
var hwDescriptionPanel = new Ext.Panel ({
  id        : 'Paraxip.wizard.descriptionPanel'
  ,region   : 'north'
  ,height   : 60
  ,minSize  : 60
  ,items    : [{}]
});

var hwDescriptionLabel = new Ext.form.Label({
  id        :  "Paraxip.wizard.descLabel"
  ,region   : 'north'
  ,text     : "Add the telephony board(s) installed on your system to the " +
              "following list:"
  ,style    : 'font-size:120%;font-weight:bold; line-height:60px;'
});

hwDescriptionPanel.add(hwDescriptionLabel)

// Hide the component that calls this method
var closeHandler = function(){
  this.hide();
};

var nextMsg = new Ext.form.Label({
  id        : "Paraxip.wizard.next_msg"
  ,region   : "south"
  ,layout   : 'fit'
  ,text     : "Click on the \"Next\" button to continue."
  ,style    : "font-size:100%;font-weight:bold; line-height:60px;text-align:" +
             "right;padding-right:15;"
});

//Grid to display added board
if( hardwareDetectionMode ) {
  var hwGridsPanel = new Ext.Panel({
    id: "Paraxip.wizard.hwPanel"
    ,region: "center"
    ,layout: "column"
  })

  // Array that contains the stores of intefaces for every bound found on the
  // system using netborder-list-boards tool. Used only when hardware detection
  // mode is enabled.
  Paraxip.wizard.interfacesStoreMap = new Paraxip.Map();

  var wizardInterfacesStore = Paraxip.createAvailableInterfacesStore({
    id: "wizardInterfacesStore"
    ,baseParams: {"isInWizard":true}
  }, Paraxip.wizard.interfacesStoreMap);

  Paraxip.wizard.availableInterfacesGrid =
      Paraxip.createAvailableInterfacesGrid({
    id      : "Paraxip.wizard.availableInterfacesGrid"
    ,store  : wizardInterfacesStore
    ,style  : 'text-align:left;padding:0 0 0 5px'
  });

  var wizardBoardsStore = Paraxip.createAvailableBoardsStore({
    id: "wizardAvailableBoardsStore"
    ,baseParams: {"isInWizard":true}
  });

  Paraxip.wizard.availableBoardsGrid = Paraxip.createAvailableBoardsGrid({
    id      : "Paraxip.wizard.board_display"
    ,store  : wizardBoardsStore
    ,style  : 'text-align:left;padding:0 5px 0 0'
  }, Paraxip.wizard.availableInterfacesGrid);

  hwGridsPanel.add( Paraxip.wizard.availableBoardsGrid );
  hwGridsPanel.add( Paraxip.wizard.availableInterfacesGrid );

  wizardInterfacesStore.on("load",function(store, records){
              
      gridInterfaces = records
      boardId = store.lastOptions.params.boardID
      boardIndex = boardId -1
      
      initBoards = Paraxip.wizard.preInitializedBoard
      if( initBoards.length == 0 ) {
        // No initial values available
        Paraxip.updateInterfacesGridHeaders(Paraxip.wizard.availableInterfacesGrid, wizardBoardsStore.getAt(boardIndex));
        return 
      }
      
      initInterfaces = initBoards[ boardIndex ].interfaces
      
      Paraxip.updateInterfacesGridHeaders(Paraxip.wizard.availableInterfacesGrid, wizardBoardsStore.getAt(boardIndex));
      
      var j =0
      for( j = 0; j < gridInterfaces.length; j=j+1) {
        gridInterface = gridInterfaces[j]
        
        var k=0
        for( k=0; k < initInterfaces.length; k=k+1 ) {
          initInterface = initInterfaces[k]
          
          if( initInterface.id == gridInterface.data.id &&
              (initInterface.wanpipe == gridInterface.data.wanpipe ||
               initInterface.wanpipe == gridInterface.data.wanpipeInterface) )
          {
            if( initInterface.active )
            {
              Paraxip.wizard.availableInterfacesGrid.getSelectionModel().selectRow( j, true )                      
            }
            gridInterface.data.phoneNumber = initInterface.phoneNumber
            gridInterface.data.callerName = initInterface.callerName
            gridInterface.data.displayName = initInterface.displayName
            gridInterface.data.active = initInterface.active
            gridInterface.commit()
          }
        }
      }
      
      Paraxip.selectInterfaces(Paraxip.wizard.availableInterfacesGrid);
    
  });
  
   
  wizardBoardsStore.on("load",function(store, records){
    updateHeaderCheckbox(Paraxip.wizard.availableInterfacesGrid, false); 
  
  boards = Paraxip.wizard.preInitializedBoard
  var i=boards.length-1;
  recurseLoadBoards( i, boards, records );
  
  /*
  for (i = boards.length-1;i >=0; i=i-1 ) {
    initBoard = boards[i]
     
    if( initBoard.active ) {      
      // Locate board in the grid
      gridBoards = records
      var j=0
      for ( j = 0; j < gridBoards.length; j=j+1) {
        gridBoard = gridBoards[j]
        if ( initBoard.pciSlot == gridBoard.data.pciSlot &&
             initBoard.pciBus == gridBoard.data.pciBus &&
             initBoard.model == gridBoard.data.model &&
             initBoard.displayName != "") 
        {
          Paraxip.wizard.availableBoardsGrid.getSelectionModel().selectRow( j, true )
          gridBoard.data.active = true
          gridBoard.data.displayName = initBoard.displayName
          gridBoard.commit()
          
          boardMatch = gridBoard
        }
      }

      Paraxip.wizard.availableInterfacesGrid.getStore().load({
            params: {"boardID":boardMatch.data.id, "gridBoardRecord":boardMatch}
      });      
    }  
  }
  */ 
  });
  
  var recurseLoadBoards = function(i, initBoards, gridBoards){
    // End recursivity
    if( i == -1 )
      return
    
    initBoard = initBoards[i]
     
    if( initBoard.active ) {      
      // Locate board in the grid
      var j=0
      for ( j = 0; j < gridBoards.length; j=j+1) {
        gridBoard = gridBoards[j]
        if ( initBoard.pciSlot == gridBoard.data.pciSlot &&
             initBoard.pciBus == gridBoard.data.pciBus &&
             initBoard.model == gridBoard.data.model &&
             initBoard.displayName != "") 
        {
          Paraxip.wizard.availableBoardsGrid.getSelectionModel().selectRow( j, true )
          gridBoard.data.active = true
          gridBoard.data.displayName = initBoard.displayName
          gridBoard.commit()
          
          boardMatch = gridBoard
        }
      }

      Paraxip.wizard.availableInterfacesGrid.getStore().load({
            params: {"boardID":boardMatch.data.id, "gridBoardRecord":boardMatch}
            ,callback: function() {
              recurseLoadBoards(--i, initBoards, gridBoards)
            }
      });      
    } else {
      // Board not active, try next one
      recurseLoadBoards(--i, initBoards, gridBoards)
    }
    
  }

} else {
//-----------------------------------------------
// Beginning of manual mode declaration
//-----------------------------------------------
  //Access variables and IDs last values
  var gridIndex = 0;
  var lastBoardID = 0;
  var lastWanpipeNum = 0;
  var isLastBoardAnalog = false;
  var lastIntNumber = 0;

  //Array containing the grid data to display to board added by the user
  var boardData = [];

  var fxsAttData = [];
  var briAttData = [];

  //Create a record type that will allow us to easily
  //add data to our grid
  DataRecord = Ext.data.Record.create([
    {name: 'board_id',type: 'int'}
    ,{name: 'model'}
    ,{name: 'num_interfaces', type: 'int'}
    ,{name: 'wanpipe', type: 'int'}
    ,{name: 'numFxoInterfaces', type: 'int'}
    ,{name: 'numFxsInterfaces', type: 'int'}
    ,{name: 'phoneNumbersArray'}
    ,{name: 'callerNamesArray'}
  ]);

  //Associates the data values with the columns of the grid
  var boardDataReader = new Ext.data.ArrayReader({}, DataRecord);

  //Store that associates the data array to our array reader
  var store = new Ext.data.Store({
    data: boardData,
    reader: boardDataReader
  });

  var clearHandler = function(){
    gridIndex = 0;
    lastBoardID = 0;
    lastWanpipeNum = 0;
    isLastBoardAnalog = false;
    lastIntNumber = 0;
  };

  store.on('clear', clearHandler);

  // Grid that lists the boards added by the user when using manual mode
  // instead of hardware detection mode
  var grid = new Ext.grid.GridPanel({
    id        : 'Paraxip.wizard.board_display'
    ,layout   : 'fit'
    ,store    : store
    ,region   : 'center'
    ,style    : 'text-align:left;'
    ,frame    : true
    ,columns  : [
      {
        id: 'boardID'
        ,header: "Board ID"
        ,width: 115
        ,dataIndex: 'board_id'
        ,css:'padding:5px;'
      }
      ,{
        header: "Board Type"
        ,width: 115
        ,dataIndex: 'model'
        ,css:'padding:5px;'
      }
      ,{
        header: "Number of Interfaces"
        ,width: 115
        ,dataIndex: 'num_interfaces'
        ,css:'padding:5px;'
      }
      ,{
        header: "Wanpipe Number"
        ,width: 115
        ,dataIndex: 'wanpipe'
        ,css:'padding:5px;'
      }
    ]
    ,enableColumnResize  : true
    ,enableColumnMove    : false
    ,enableHdMenu        : false
    ,trackMouseOver      : true
    ,stripeRows          : false
    ,autoExpandColumn    : 'boardID'
    ,sm: new Ext.grid.RowSelectionModel({singleSelect:true})
  });

  var board_type_select = Paraxip.createBoardSelectionComboBox({
    id: 'Paraxip.wizard.board_type_select'
  });

  var numFxoInterfaces = Paraxip.createAnalogInterfaceNumComboBox({
    id: 'Paraxip.wizard.numFxoInterfaces'
    ,fieldLabel: "Number of FXO Interfaces"
    ,name: "interfaceNumFXO"
  });

  var numFxsInterfaces = Paraxip.createAnalogInterfaceNumComboBox({
    id: 'Paraxip.wizard.numFxsInterfaces'
    ,fieldLabel: "Number of FXS Interfaces"
    ,name: "interfaceNumFXS"
  });

  var interfaces_num_virtual_digital = Paraxip.createVirtualInterfaceNumField({
    id: 'Paraxip.wizard.interfaces_num_virtual_digital'
  });

  var numBriInterfaces = Paraxip.createBRIInterfaceNumComboBox({
    id: 'Paraxip.wizard.numBriInterfaces'
    ,fieldLabel: "Number of BRI Interfaces"
    ,name: "interfaceNumBRI"
  });

  board_type_select.on(
    'select',
    Paraxip.showInterfaceNumberListener.createDelegate(
      board_type_select,
      [numFxoInterfaces, numFxsInterfaces, interfaces_num_virtual_digital, numBriInterfaces]
    )
  );

  //Return the number of interfaces on the board according to
  //its name.
  var getDigitalBoardInterfacesNumber = function(boardType) {
    return parseInt(boardType.charAt(boardType.length - 1), 10);
  };

  //---------------------------------------------------------------------------
  // Phone number selection window methods
  //---------------------------------------------------------------------------
  FxsAttDataRecord = Ext.data.Record.create([
    {name: 'interface_id',type: 'int'}
    ,{name: 'phone_number'}
    ,{name: 'caller_name'}
  ]);
  
  BriAttDataRecord = Ext.data.Record.create([
     {name: 'interface_id',type: 'int'}
     ,{name: 'briModType'}
  ]);

  //Associates the data values with the columns of the grid
  var fxsAttDataReader = new Ext.data.ArrayReader({}, FxsAttDataRecord);
  var briAttDataReader = new Ext.data.ArrayReader({}, BriAttDataRecord);

  //Store that associates the data array
  //to our array reader
  var fxsAttStore = new Ext.data.Store({
    data: fxsAttData,
    reader: fxsAttDataReader
  });
  
  //Store that associates the data array
  //to our array reader
  var briAttStore = new Ext.data.Store({
    data: briAttData,
    reader: briAttDataReader
  });

  var fxsAttributesGrid = Paraxip.createFxsAttributesGrid({
    id: "Paraxip.wizard.fxsAttributesGrid"
    ,store: fxsAttStore
  });
  
  var briAttributesGrid = Paraxip.createBriAttributesGrid({
    id: "Paraxip.wizard.briAttributesGrid"
    ,store: briAttStore
  });
  
  var fxsPhoneNumbersWindow = new Ext.Window({
    title       : 'Edit FXS interfaces attributes'
    ,layout     : 'border'
    ,width      : 505
    ,height     : 400
    ,closable   : false
    ,plain      : true
    ,id         : "Paraxip.wizard.fxsPhoneNumbersWindow"
  });
  var briWindow = new Ext.Window({
    title       : 'Edit BRI interfaces attributes'
    ,layout     : 'border'
    ,width      : 505
    ,height     : 400
    ,closable   : false
    ,plain      : true
    ,id         : "Paraxip.wizard.briWindow"
  });

  fxsPhoneNumbersWindow.add(fxsAttributesGrid);
  briWindow.add(briAttributesGrid);

  // Add to fxsPhoneNumbersPanel, a phone number field for each fxs interfaces
  // selected in the Add Board Window.
  var addPhoneNumberFields = function() {
    var i = 1;
    fxsAttStore.removeAll();
    var numIfs = 
      parseInt(numFxsInterfaces.getRawValue(), 10) +
      parseInt(numFxoInterfaces.getRawValue(), 10);
    for( i ; i <= numIfs; ++i ) {
      if( i <= parseInt(numFxoInterfaces.getRawValue(), 10) ) {
        var callerName = "N/A - FXO interface";
      } else {
        var callerName = "user" + i;
      }
      fxsAttStore.add( new FxsAttDataRecord({
        'interface_id':i
        ,'phone_number': "phoneNumber" + i
        ,'caller_name': callerName
      }));
    }
  }
  
  var addBriModTypeFields = function() {
    var i = 1;
    briAttStore.removeAll();
    for( i ; i <= numBriInterfaces.getRawValue(); ++i ) {
      briAttStore.add( new FxsAttDataRecord({
        'interface_id':i
        ,'briModType': "TERMINAL"
      }));
    }
  }

  var savePhoneNumbersHandler = function() {
    var phoneNumbers = [];
    var callerNames = [];
    var fxsAttRecord;
    var i = 0;
    var j = 0;
    var numIfs =
      parseInt(numFxsInterfaces.getRawValue(), 10) +
      parseInt(numFxoInterfaces.getRawValue(), 10);

    for( i; i < numIfs; i++ ) {
      fxsAttRecord = fxsAttStore.getAt(i);

      for( j=0; j <= numIfs; j++) {
        if( phoneNumbers[j] == fxsAttRecord.data.phone_number ) {
          Ext.Msg.alert(
            "Duplicated Phone Numbers",
            "Two interfaces have the same phone number (" + phoneNumbers[j] +
            "). Each analog interfaces must have a unique phone number."
          );
          return;
        }
      }
      phoneNumbers[i] = fxsAttRecord.data.phone_number;
      callerNames[i] = fxsAttRecord.data.caller_name;
    }

    var interfacesNum = parseInt(numFxoInterfaces.getRawValue(), 10);

    interfacesNum += parseInt(numFxsInterfaces.getRawValue(), 10);

    var newRecord = new DataRecord({
      'board_id':lastBoardID
      ,'model':board_type_select.getValue()
      ,'num_interfaces':interfacesNum
      ,'wanpipe':lastWanpipeNum
      ,'numFxoInterfaces':parseInt(numFxoInterfaces.getRawValue(), 10)
      ,'numFxsInterfaces':parseInt(numFxsInterfaces.getRawValue(), 10)
      ,'phoneNumbersArray':phoneNumbers
      ,'callerNamesArray':callerNames
    });

    store.add(newRecord);

    fxsPhoneNumbersWindow.hide();

  }
  
  var saveBriSettingsHandler = function() {
    var briModTypeList = [];
    var i = 0;
    var j = 0;

    for( i; i < numBriInterfaces.getRawValue(); i++ ) {
      var briAttRecord = briAttStore.getAt(i);
      briModTypeList[i] = briAttRecord.data.briModType;
    }

    var interfacesNum = parseInt(numBriInterfaces.getRawValue(), 10);
    
    var newRecord = new DataRecord({
      'board_id':lastBoardID
      ,'model':board_type_select.getValue()
      ,'num_interfaces':interfacesNum
      ,'wanpipe':lastWanpipeNum
      ,'briModType':briModTypeList
    });

    store.add(newRecord);

    briWindow.hide();

  }

  fxsAttributesGrid.addButton({
    id:"Paraxip.wizard.addPhoneNumbersButton",text:"Save"
  }, savePhoneNumbersHandler);

  fxsAttributesGrid.addButton({
    id:"Paraxip.wizard.cancelFxsAttributesButton",text:"Cancel"
  }, function(){fxsPhoneNumbersWindow.hide();});
  
  briAttributesGrid.addButton({
    id:"Paraxip.wizard.addBriAttributesButton",text:"Save"
  }, saveBriSettingsHandler);

  briAttributesGrid.addButton({
    id:"Paraxip.wizard.cancelBriAttributesButton",text:"Cancel"
  }, function(){briWindow.hide();});

  //---------------------------------------------------------------------------
  // Boards selection window methods
  //---------------------------------------------------------------------------
  var optionsPanel = Paraxip.createAddBoardPanel({});

  var optionsWindow = new Ext.Window({
    title       : 'Add Board Window'
    ,layout     : 'border'
    ,width      : 505
    ,height     : 200
    ,closeAction: 'hide'
    ,plain      : true
    ,id         : "Paraxip.wizard.options_window"
  });

  //Method called when the add button is clicked
  var saveBoardsHandler = function() {
    var boardType = board_type_select.getValue();
    var isAnalog = Paraxip.isBoardAnalog(boardType);
    var isVirtualDigital = Paraxip.isBoardVirtualDigital(boardType);
    var isBRI = Paraxip.isBoardBRI(boardType);
    var interfacesNum;

    if (isAnalog) {
      interfacesNum = parseInt(numFxoInterfaces.getRawValue(), 10);
      interfacesNum += parseInt(numFxsInterfaces.getRawValue(), 10);

      if( interfacesNum < Paraxip.minAnalogInterfaces
          || interfacesNum > Paraxip.maxAnalogInterfaces ) {
        Ext.Msg.alert("Wrong number of analog interfaces",
          "The total number of analog interfaces (fxo interfaces " +
          "+ fxs interfaces) must be at least " +
          Paraxip.minAnalogInterfaces + " interfaces and not more " +
          "than " + Paraxip.maxAnalogInterfaces + " interfaces.");
        return;
      }
    } else if (isVirtualDigital) {
      interfacesNum =
        parseInt(interfaces_num_virtual_digital.getRawValue(), 10);
    } else if(isBRI){
      interfacesNum =
        parseInt(numBriInterfaces.getRawValue(), 10);
      if( interfacesNum < Paraxip.minBriInterfaces
          || interfacesNum > Paraxip.maxBriInterfaces ) {
        Ext.Msg.alert("Wrong number of BRI interfaces",
          "The total number of BRI interfaces must be at least " +
          Paraxip.minBriInterfaces + " interfaces and not more " +
          "than " + Paraxip.maxBriInterfaces + " interfaces.");
        return;
      }
    }
    else{
      interfacesNum = getDigitalBoardInterfacesNumber(boardType);
    }

    lastBoardID = lastBoardID + 1;

    if (lastWanpipeNum === 0) {
      lastWanpipeNum = 1;
    } else if (isLastBoardAnalog) {
      lastWanpipeNum = lastWanpipeNum + 1;
    } else {
      lastWanpipeNum = lastWanpipeNum + lastIntNumber;
    }

    lastIntNumber = interfacesNum;
    isLastBoardAnalog = isAnalog;

    if( isAnalog && interfacesNum > 0 ) {
      addPhoneNumberFields();
      fxsPhoneNumbersWindow.show(grid);
      // Since we need to wait for Fxs interfaces phone numbers, the record
      // will be added at the end of the savePhoneNumbers method.
    } 
    else if(isBRI){
      addBriModTypeFields();
      briWindow.show(grid);
    }
    else {
      // Add the record now if we don't need the phone numbers for fxs
      // interfaces
      var newRecord = new DataRecord({
        'board_id':lastBoardID
        ,'model':boardType
        ,'num_interfaces':interfacesNum
        ,'wanpipe':lastWanpipeNum
        ,'numFxoInterfaces':parseInt(numFxoInterfaces.getRawValue(), 10)
        ,'numFxsInterfaces':parseInt(numFxsInterfaces.getRawValue(), 10)
        ,'phoneNumbersArray':[]
        ,'callerNamesArray':[]
      });

      store.add(newRecord);
    }

    optionsWindow.hide();

  };

  optionsWindow.add(optionsPanel);
  optionsPanel.add(board_type_select);
  optionsPanel.add(numFxoInterfaces);
  optionsPanel.add(numFxsInterfaces);
  optionsPanel.add(interfaces_num_virtual_digital);
  optionsPanel.add(numBriInterfaces);

  optionsPanel.addButton({
    id:"Paraxip.wizard.addBoardButton",text:"Add"
  }, saveBoardsHandler, grid);
  optionsPanel.addButton({
    id:"Paraxip.wizard.cancelBoardButton",text:"Cancel"
  }, closeHandler, optionsWindow);

  // Show only necessary fields once layout is done
  optionsPanel.on(
    'afterlayout',
    Paraxip.showInterfaceNumberListener.createDelegate(
      board_type_select,
      [numFxoInterfaces, numFxsInterfaces, interfaces_num_virtual_digital, numBriInterfaces]
    )
  );

  //Method called when the add button is clicked
  var addHandler = function() {
    optionsWindow.show(grid);
  };

  //When a board is removed, we need to decrease the id of every
  //board currently in the board_data array
  var reassignBoardId = function(e) {
    var newId = store.indexOf(e) + 1;
    e.set('board_id', newId);
  };

  // Reassing all the wanpipe numbers for each board. If the previous
  // board is analog, the wanpipe number is increased by 1. If the previous
  // board is digital, the wanpipe number is increased by the number
  // of interfaces that contains that previous board.
  var reassignWanpipeNumber = function(e) {
    var index = store.indexOf(e);

    if (index === 0) {
      e.set('wanpipe', 1);
      lastWanpipeNum = 1;
    } else {
      if (isLastBoardAnalog) {
        lastWanpipeNum = lastWanpipeNum + 1;
      } else {
        lastWanpipeNum = lastWanpipeNum + lastIntNumber;
      }
      e.set('wanpipe', lastWanpipeNum);
    }

    lastIntNumber = e.get('num_interfaces');
    isLastBoardAnalog = Paraxip.isBoardAnalog(e.get('model'));

  };

  //Called when the remove button is clicked
  var removeHandler = function() {
    var selectedRecord = grid.getSelectionModel().getSelected();

    if (selectedRecord !== undefined) {
      store.remove(selectedRecord);

      lastWanpipeNum = 0;
      lastIntNumber = 0;
      store.each(reassignBoardId);
      store.each(reassignWanpipeNumber);

      lastBoardID = lastBoardID - 1;
    }
  };

  grid.addButton({
    id:"Paraxip.wizard.showBoardSelection"
    ,text:"Add Board"
  }, addHandler, grid);

  grid.addButton("Remove Board", removeHandler, grid);
} // end of if( hardwareDetectionMode )

hardware_form.add(hwDescriptionPanel);

if( hardwareDetectionMode ) {
  hardware_form.add(hwGridsPanel);
} else{
  hardware_form.add(grid);
}
hardware_form.add(nextMsg);
